<?php
//    Copyright 2010 Andrii Salnikov
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
    error_reporting(E_ALL);
    header("Cache-Control: no-cache");
    header("Pragma: no-cache");
    header("Content-Type: text/xml;charset=ISO-8859-1");
    ini_set("display_errors", 1);
    ini_set("include_path", "./interfaces:./modules:./lang:./conf");
    require("config.inc");
    require("get_vo_configuration.php");

    class SOAP_Methods {
	/****** SOAP answer forming *********/
	private function ConstructXML($method, $type, $value, $array_type="soapenc:string") {
		echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		echo "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"><soapenv:Body>";
		echo "<". $method ."Response soapenv:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">";
		if ( is_array($value) ) {
			switch ($array_type){
				case "ns1:User":
					echo "<".$method."Return soapenc:arrayType=\"ns1:User[". count($value) ."]\" xsi:type=\"soapenc:Array\" xmlns:ns1=\"http://glite.org/wsdl/services/org.glite.security.voms\" xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\">";
					$count = 0;
					foreach ( $value as $v ) {
						echo "<".$method."Return href=\"#id". $count . "\"/>";
						$count++;
					}
					echo "</".$method."Return></".$method."Response>";
					$count = 0;
					foreach ( $value as $v ) {
						$nscount = $count + 2;
						echo "<multiRef id=\"id".$count."\" soapenc:root=\"0\" soapenv:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\" xsi:type=\"ns".$nscount.":User\" xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\" xmlns:ns".$nscount."=\"http://glite.org/wsdl/services/org.glite.security.voms\" >";
						foreach ( $v as $kn => $kv ) {
							if ( $kv !== NULL ) {
								echo "<".$kn." xsi:type=\"soapenc:string\">".$kv."</".$kn.">";
							} else {
								echo "<".$kn." xsi:type=\"soapenc:string\" xsi:nil=\"true\"/>";
							}
						}
						echo "</multiRef>";
						$count++; 
					}
					break;
				case "soapenc:string":
					echo "<".$method."Return soapenc:arrayType=\"".$array_type."[". count($value) ."]\" xsi:type=\"soapenc:Array\" xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\">";
					foreach ( $value as $v ) {
						echo "<".$method."Return xsi:type=\"".$type."\">".$v."</".$method."Return>";
					}
					echo "</".$method."Return></".$method."Response>";
					break;
			}
		} else {
			echo "<".$method."Return href=\"#id0\"/></".$method."Response>";
			echo "<multiRef id=\"id0\" soapenc:root=\"0\" soapenv:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\" xsi:type=\"".$type."\" xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\">".$value."</multiRef>";
		}
		echo "</soapenv:Body></soapenv:Envelope>";
	}

	private function FaultXML($text, $code = "ns1:Client" ) {
		echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?><soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"><soapenv:Body><soapenv:Fault><faultcode xmlns:ns1=\"http://xml.apache.org/axis/\">".$code."</faultcode><faultstring>".$text."</faultstring><detail><ns2:hostname xmlns:ns2=\"http://xml.apache.org/axis/\">". $_SERVER["SERVER_NAME"] ."</ns2:hostname></detail></soapenv:Fault></soapenv:Body></soapenv:Envelope>";
	}
	/***** Supported SOAP methods *****/
	function getMajorVersionNumber() {
		$value = getVersion();
		SOAP_Methods::ConstructXML("getMajorVersionNumber", "xsd:int", $value);
	}
	function getMinorVersionNumber() {
		$value = 0;
		SOAP_Methods::ConstructXML("getMinorVersionNumber", "xsd:int", $value);
	}
	function getPatchVersionNumber() {
		$value = 2;
		SOAP_Methods::ConstructXML("getPatchVersionNumber", "xsd:int", $value);
	}
	function getGridmapUsers ( $container = "" ) {
		if ( $container !== "" ) {
			$matches = array ();
			if ( preg_match("/^((\/[-a-zA-Z0-9_.]+)+)(\/Role=[-a-zA-Z0-9_.]+)?(\/Capability=[-a-zA-Z0-9_ .]+)?$/", $container, $matches ) ) {
				// Parse container
				$group = $matches[1];
				unset($matches[0]);
				unset($matches[1]);
				unset($matches[2]);
				$matchrole = array (); $matchcap = array ();
				foreach( $matches as $mv ) {
					if ( preg_match("/^\/Role=([-a-zA-Z0-9_.]+)$/", $mv, $matchrole ) ) {
						$role = $matchrole[1];
					};
					if ( preg_match("/^\/Capability=([-a-zA-Z0-9_ .]+)$/", $mv, $matchcap) ) {
						$capability = $matchcap[1];
					};
				}
				$capability = isset($capability) ? $capability : NULL;
				$role = isset($role) ? $role : NULL;

				$value = getVOContainerMembers($group, $role, $capability);
			} else {
				SOAP_Methods::FaultXML("org.glite.security.voms.admin.common.VOMSSyntaxException: Syntax error in container name: ".$container, "soapenv:Server.userException");
				return 1;
			}
		} else {
			$value = getVOMembers();
		}
		SOAP_Methods::ConstructXML("getGridmapUsers", "soapenc:string", $value);
	}

	function listMembers () {
		$value = getAllUsersInfo();
		if ( $value === 0 ) { 
			SOAP_Methods::FaultXML("org.glite.security.voms.admin.common.VOMSDatabaseException: Can not retrieve members information", "soapenv:Server.userException");
			return 1;
		}
		SOAP_Methods::ConstructXML("listMembers", "soapenc:Array", $value, "ns1:User");
	}

	function __call( $name, $args ) {
		/**** Call if method exists *****/
		if( method_exists( $this, $name ) )
	          	return $this->$name( $args );
		/**** Otherwice return Fault XML *****/
		SOAP_Methods::FaultXML("No such operation '".$name."'");
  	}
	
    }

// WSDL URL
$wsdl_url = 'https://'.$_SERVER['HTTP_HOST'].preg_replace('/\?.*/','',$_SERVER['REQUEST_URI']);

// return wsdl
if ( isset($_GET['wsdl']) ) {
        $wsdl = file_get_contents('wsdl/voms-compatibility-2.0.2.wsdl');
        echo preg_replace('/@@ENDPOINT@@/',$wsdl_url,$wsdl);
        exit(0);
}

if ( ! $isfailed ) {
	if ($_SERVER["REQUEST_METHOD"] == "POST") {
		$raw_post = file_get_contents('php://input');
		$matches = array ();
		# check methods with no parameters
		$num_of_matches = preg_match('/<([^>\/ ]*)(getGridmapUsers|getMinorVersionNumber|getMajorVersionNumber|getPatchVersionNumber|listMembers)([^>\/]*)(\/>|><\/([^>]+)>)/',$raw_post,$matches);
		if ( ! $num_of_matches ) {
			file_put_contents('/tmp/pva-compat',$raw_post);
			# check for getGridmapUsers with container parameter
			$matches = array ();
			if ( preg_match('/<([^>\/ ]*)(getGridmapUsers)([^>\/]*)><[^>\/]+>([^<]*)<\/[^>\/]+>/',$raw_post,$matches)){
				$_REQ["method"] = $matches[2];
				$_REQ["container"] = $matches[4];
			}
			file_put_contents('/tmp/pva-compat-parms',var_export($matches,true));
		} else $_REQ["method"] = $matches[2];
	} else $_REQ = $_GET;

	if(isset($_REQ["method"])) {
		$csoap = new SOAP_Methods;
	        $method = $_REQ["method"];
		$container = next($_REQ);
		while (( $container == $vo ) || ( $container == $method ))
			 $container = next($_REQ);
		if ( ($container === "FALSE") || (! $container) ) { $csoap->$method(); } else { $csoap->$method($container); }
	    } else {
		echo "<h1>VOMSCompatibility</h1>\n<p>PHP VOMS-Admin</p><i><b>Error:</b> method not specified</i>";
	}
} else echo "<h1>VOMSCompatibility</h1>\n<p>PHP VOMS-Admin</p><i><b>Error:</b> VO not specified or not served</i>";

?>
