<?php
//    Copyright 2010 Andrii Salnikov
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//

ini_set('include_path',ini_get('include_path').':/usr/share/php/PHPMailer:');
//UBUNTU_PHPMAILER//ini_set('include_path',ini_get('include_path').':/usr/share/php/libphp-phpmailer:');
require_once("class.phpmailer.php");
	
function send_userconfirm_mail($vo, $base_url, $regcode, $usercn, $usermail, $is_service=0)
{
	global $voms_registration_mail_confirm_subject, $voms_registration_mail_confirm;
	global $mail_from, $mail_from_name;

	$regcode_url_appr = $base_url . "&action=confirmation&l=".rand(1000,9999)."&u=0&c=". urlencode($regcode);
	$regcode_url_disappr = $base_url . "&action=confirmation&l=".rand(1000,9999)."&u=1&c=". urlencode($regcode);

    if ( $is_service ) {
        $regcode_url_appr .= "&s=1";
        $regcode_url_disappr .= "&s=1";
    }

	$text = sprintf($voms_registration_mail_confirm, $usercn, $vo, $regcode_url_appr, $vo, $regcode_url_disappr, $vo);
	$subject = sprintf($voms_registration_mail_confirm_subject, $vo);
	if(!$text) return false;

	try {
		$mail = new PHPMailer(true);
		$mail->IsSMTP();
		$mail->AddAddress($usermail, $usercn);
		$mail->SetFrom($mail_from, $mail_from_name);
		$mail->CharSet = "UTF-8";
		$mail->Encoding = "quoted-printable";
		$mail->Subject = "=?UTF-8?B?".base64_encode($subject)."?=\n";
		$mail->Body = $text;
		$mail->Send();
	} catch(Exception $e) {
		print $e->getMessage();
		return false;
	}
	return true;
}

function send_usernotify_mail($vo, $usercn, $usermail, $approved) {
	global $voms_registration_mail_userinform_subject, $voms_registration_mail_userinform;
	global $mail_from, $mail_from_name;

	$subject = sprintf($voms_registration_mail_userinform_subject, $vo, $approved);
	$text = sprintf($voms_registration_mail_userinform, $usercn, $vo, $approved, $vo); 
        if(!$text) return false;

        try {
                $mail = new PHPMailer(true);
                $mail->IsSMTP();
                $mail->AddAddress($usermail, $usercn);
                $mail->SetFrom($mail_from, $mail_from_name);
                $mail->CharSet = "UTF-8";
                $mail->Encoding = "quoted-printable";
                $mail->Subject = "=?UTF-8?B?".base64_encode($subject)."?=\n";
                $mail->Body = $text;
                $mail->Send();
        } catch(Exception $e) {
                print $e->getMessage();
                return false;
        }
        return true;
}

function send_adminnotify_mail($vo, $base_url, $admcn, $admmail, $reqinfo)
{
	global $voms_registration_mail_admin_subject, $voms_registration_mail_admin;
	global $mail_from, $mail_from_name;

	$url = $base_url . "&action=subscriptions";

	$text = sprintf($voms_registration_mail_admin, $admcn, $vo, $reqinfo["dn"], $reqinfo["ca"], $reqinfo["mail"], $reqinfo["inst"], $reqinfo["phone"], $reqinfo["cmnt"], $url, $vo);

	$subject = sprintf($voms_registration_mail_admin_subject, $vo);
	if(!$text) return false;

	try {
		$mail = new PHPMailer(true);
		$mail->IsSMTP();
		$mail->AddAddress($admmail, $admcn);
		$mail->SetFrom($mail_from, $mail_from_name);
		$mail->CharSet = "UTF-8";
		$mail->Encoding = "quoted-printable";
		$mail->Subject = "=?UTF-8?B?".base64_encode($subject)."?=\n";
		$mail->Body = $text;
		$mail->Send();
	} catch(Exception $e) {
		print $e->getMessage();
		return false;
	}
	return true;
}

function send_message_for_vomsadmin($from,$replyto,$message)
{
	global $voms_admin_mail, $mail_from, $mail_from_name, $voms_admin_mail;
	global $voms_sendmail_foradm_subject;

	$subject = sprintf($voms_sendmail_foradm_subject, $from);

	try {
                $mail = new PHPMailer(true);
                $mail->IsSMTP();
                $mail->AddAddress($voms_admin_mail);
                $mail->SetFrom($mail_from, $mail_from_name);
		$mail->AddReplyTo($replyto, $from);
                $mail->CharSet = "UTF-8";
                $mail->Encoding = "quoted-printable";
                $mail->Subject = "=?UTF-8?B?".base64_encode($subject)."?=\n";
                $mail->Body = $message;
                $mail->Send();
        } catch(Exception $e) {
                print $e->getMessage();
                return false;
        }
        return true;
}

function send_request_for_newvo($from,$replyto,$message)
{
        global $voms_admin_mail, $mail_from, $mail_from_name, $voms_admin_mail;
        global $voms_sendmail_newvo_subject;

        $subject = $voms_sendmail_newvo_subject; 

        try {
                $mail = new PHPMailer(true);
                $mail->IsSMTP();
                $mail->AddAddress($voms_admin_mail);
                $mail->SetFrom($mail_from, $mail_from_name);
                $mail->AddReplyTo($replyto, $from);
                $mail->CharSet = "UTF-8";
                $mail->Encoding = "quoted-printable";
                $mail->Subject = "=?UTF-8?B?".base64_encode($subject)."?=\n";
                $mail->Body = $message;
                $mail->Send();
        } catch(Exception $e) {
                print $e->getMessage();
                return false;
        }
        return true;
}

?>
